#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;

$n=0;
open(DIR,"ls GAS.*.cube.fits.gz |");
while($file=<DIR>) {
    chop($file);
    $name=$file;
    $cut=".cube.fits.gz";
    $name =~ s/$cut//;
    $cut="GAS.";
    $name =~ s/$cut//;
    $FILE[$n]=$file;
    $NAME[$n]=$name;
    $n++;
}
close(DIR);

open(LOG,">CS_slice_V14.log");
for ($i=0;$i<$n;$i++) {
    print DO "$NAME[$i],2\n";
    $call="get_CS_slice.pl ".$NAME[$i];
    mycall($call);
}

close(LOG);

exit;

sub mycall {                                      
                                                                   my $call=$_[0];

														     print "$call | PROCESSING\n";                                                                                 
    system($call);                                                                                                
    print LOG "$call\n";                                                                                          
    print "DONE\n";                                                                                              
} 
