#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;

$n=0;
open(DIR,"ls HII.*.rss.pt.txt |");
while($file=<DIR>) {
    chop($file);
    $name=$file;
    $cut=".rss.pt.txt";
    $name =~ s/$cut//;
    $cut="HII.";
    $name =~ s/$cut//;
    $FILE[$n]=$file;
    $NAME[$n]=$name;
    $n++;
}
close(DIR);

open(LOG,">HII_pt_V14.log");
for ($i=0;$i<$n;$i++) {
    print DO "$NAME[$i],2\n";
    $call="spec_extract_cube.pl ".$NAME[$i].".V500.zcube.fits.gz seg_Ha.".$NAME[$i].".fits.gz HII.".$NAME[$i].".rss.fits.gz seg_diff.".$NAME[$i].".fits.gz";
    mycall($call);
    $call="cp HII.".$NAME[$i].".rss.pt.txt.gz HII.".$NAME[$i].".rss.pt.txt ";
    mycall($call);
}

close(LOG);

exit;

sub mycall {                                      
                                                                   my $call=$_[0];

														     print "$call | PROCESSING\n";                                                                                 
    system($call);                                                                                                
    print LOG "$call\n";                                                                                          
    print "DONE\n";                                                                                              
} 
