#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;
$vel_light=299792.458;

#$plot=2;

#
$plot=2; $plot_rss=0;

# $plot=2; $plot_rss=2;
#$plot=1; $plot_rss=1;

#$DIR_WORK="CALIFA_PATH/SSP/SEG/";
#$DIR_CONF="legacy/";
$DIR_CONF="../legacy/";
#legacy/
#$DIR_DATA="CALIFA_PATH/V500/reduced_v1.3c/";
#$DIR_DATA="CALIFA_PATH/V500/reduced_v2.2/";
$DIR_DATA="CALIFA_PATH/V500/reduced_v2.2/";
#chdir($DIR_WORK);
$max_size=10;
$frac=0.9;
#$template="legacy/miles_2.fits";
#$template="legacy/miles_12.fits";
#$template="legacy/miles_6.fits";
#legacy/gsd61_156.fits,legacy/miles_2.fits

$template="legacy/gsd01_156.fits";
$temp_2="legacy/miles_3.fits";

$temp_3="legacy/gsd01_12.fits";
$temp_4="legacy/miles_2_gas.fits";

$config="auto_ssp_V500_several.config";
$config_no="auto_ssp_V500_no_lines.config";
$config_SII="auto_ssp_V500_several_SII_z.config";
#$config_no="auto_ssp_V500_no_lines.config";
#$config="auto_ssp_V500_several.few.config";

#
#$template="legacy/miles_6.fits";
#$template="legacy/miles_20.fits";
#$template="legacy/miles_4.fits";

if ($#ARGV<0) {
    print "ana_single.pl NAME\n";
    exit;
}
$NAME=$ARGV[0];
$FILE=$DIR_DATA."/".$NAME.".V500.rscube.fits.gz";

$logfile="ana_single.".$NAME.".log";
open(LOG,">$logfile");

$init_time=print_time();

$call="get_slice.pl ".$FILE." img_".$NAME." ".$DIR_CONF."/slice_V.conf"; 
mycall($call);   
$V_img="img_".$NAME."_V_4500_5500.fits";
$img=rfits($V_img);                                             
($nx,$ny)=$img->dims;    
$img_mask=zeroes($nx,$ny);
$V_mask="../masks_V500_v1.5/".$NAME.".V500.mask.fits";
$nx1=$nx; $ny1=$ny;
eval {
    $img_mask=rfits($V_mask);
    ($nx1,$ny1)=$img_mask->dims;    
};




print "DIM = $nx,$ny,$nx1,$ny1\n"; 
         
$img_mask_new=ones($nx,$ny);;
#for ($ii=0;$ii<$nx1;$ii++) {                                                     
#    for ($jj=0;$jj<$ny1;$jj++) {                                                 

if ($nx1>$nx) {
    $nx1=$nx;
} 

if ($ny1>$ny) {
    $ny1=$ny;
} 
 
for ($ii=0;$ii<$nx1;$ii++) {                                                     
    for ($jj=0;$jj<$ny1;$jj++) {                                                 
	$val_mask=$img_mask->at($ii,$jj);                                                 
	if ($val_mask==2) {
	    set($img_mask_new,$ii,$jj,0);
	} else {
	    set($img_mask_new,$ii,$jj,1);
	}
    }
}
$V_mask=$NAME.".V500.mask.fits";
$img_mask_new->wfits($V_mask);
            
print "PASO\n";                        
$val_max=-1e12;                                                                 
$XC=0;                                                                         
$YC=0;                        
$SUM=0;                                                 
for ($ii=30;$ii<45;$ii++) {                                                     
    for ($jj=30;$jj<45;$jj++) {                                                 
	$val=$img->at($ii,$jj);                                                 
	$val_mask=$img_mask->at($ii,$jj);                                                 
	if ($val_mask!=2) {
	    $XC=$XC+$ii*($val)**5;                                                            
	    $YC=$YC+$jj*($val)**5;                                                           
	    $SUM=$SUM+($val)**5;
	}
    }                                                                           
}   
$XC=$XC/$SUM;
$YC=$YC/$SUM;
$call="cp ".$V_img." ".$NAME.".V.fits";
mycall($call);
$call="clean_nan.pl  ".$NAME.".V.fits -1";
mycall($call);
#$call="radial_sum_cube.pl ".$FILE." 2.5 ".$XC." ".$YC." rad.".$NAME.".rss.fits 2"; 
#mycall($call);                                                                     
$call="./radial_sum_cube_e.pl ".$FILE." 2.5 ".$XC." ".$YC." rad.".$NAME.".rss.fits 2"; 
mycall($call);                                                                     
$call="./img2spec_e.pl rad.".$NAME.".rss.fits 0 ".$NAME.".spec_5.txt";
mycall($call);                                                                     
$call="./img2spec_e.pl rad.".$NAME.".rss.fits 5 ".$NAME.".spec_30.txt";
mycall($call);                                             

#exit;

$call="read_img_header.pl ".$FILE." MED_VEL > SYS_VEL_NOW_".$NAME;
mycall($call);
$sys_vel_now="SYS_VEL_NOW_".$NAME;
open(VEL,"<$sys_vel_now");
$dat=<VEL>; chop($dat);
close(VEL);
($key,$vel)=split(" ",$dat);
$vel =~ s/ //g;
$vel=0;



$call="vel_eline_spec.pl ".$NAME.".spec_5.txt 2 0.7 junk 3728 OII_".$NAME.".ps/CPS 3700 4000 > vel_eline_spec.".$NAME.".txt";
mycall($call);

$f_eline="vel_eline_spec.".$NAME.".txt";
open(FE,"<$f_eline");
$fe=<FE>; chop($fe); @dat_fe=split(",",$fe);
close(FE);

#
# Define the redshift by OII, if it is clearly detected!
#
if (($dat_fe[1]==1)&&($vel==0)) {
    $vel=$dat_fe[2];
    $red=$vel/$vel_light;
    $min_red=$red-300/$vel_light;
    $max_red=$red+300/$vel_light;
    $d_red=30/$vel_light;
#    $call="write_img_header.pl ".$FILE." MED_VEL ".$vel;
#    mycall($call);
} else {
    $red=0.02;
    $min_red=0.0045;
    $max_red=0.032;
    $d_red=30/$vel_light;
}

$red=0.02;
$min_red=0.0045;
$max_red=0.032;
$d_red=150/$vel_light;


#auto_ssp_elines_rnd.pl NGC0447.spec_5.txt legacy/gsd61_12.fits,legacy/miles_2_gas.fits auto_ssp.NGC5394.cen.out ../legacy//mask_elines.txt ../legacy/auto_ssp_V500_several.config 1 -3 50 3800,3850 7000,5200 none 0.01 0.001 0.0045 0.032 3.2 0.3 1.2 5.5 0.3 0.15 0.0 1.


$call="auto_ssp_elines_rnd.pl  ".$NAME.".spec_5.txt ".$temp_3.",".$temp_4." auto_ssp_Z.".$NAME.".cen.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config_no." 0 -3 50 3800,3850 7000,4700 none ".$red." ".$d_red." ".$min_red." ".$max_red." 3.2 0.3 1.2 5.5 0.3 0.15 0.0 1.6";
mycall($call);

$vel=0;
$disp_MAX=5.5;
if ($vel==0) {
    $outfile="auto_ssp_Z.".$NAME.".cen.out";
    open(RED,"<$outfile");
    while($RED=<RED>) {
	if ($RED !~ "#") {
	    chop($RED);
	    @RED_DATA=split(",",$RED);
	    $red=$RED_DATA[7];
	    $min_red=$red-300/$vel_light;
	    $max_red=$red+300/$vel_light;
	    $d_red=30/$vel_light;
	    $vel=$red*$vel_light;
	    $disp_MAX=1.5*$RED_DATA[9];#+1.5*$RED_DATA[10];
	    print "RED=$red VEL=$vel\n";
	}
    }
    close(RED);
}

#
# KM/H
#

$call="auto_ssp_elines_rnd_sigma_inst.pl  ".$NAME.".spec_5.txt ".$template.",".$temp_2.",1.1 auto_ssp.".$NAME.".cen.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot." -3 50 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." 0 ".$min_red." ".$max_red."  30 20 1 400 0.0 0.15 0.0 1.6";
mycall($call);


$disp_MAX=100;
$outfile="auto_ssp.".$NAME.".cen.out";
open(RED,"<$outfile");
while($RED=<RED>) {
    if ($RED !~ "#") {
	chop($RED);
	@RED_DATA=split(",",$RED);
	$DISP_MAX=$RED_DATA[9]+30;
    }
}
close(RED);




$call="auto_ssp_elines_rnd_sigma_inst.pl  ".$NAME.".spec_30.txt ".$template.",".$temp_2.",1.1 auto_ssp.".$NAME.".int.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot." -3 150 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 30 20 1 400 0.3 0.15 0.0 1.6";
mycall($call);

#exit;
#exit;
#exit;

#$V_file=$NAME.".V.fits";
#$pdl_V=rfits($V_file);
#($nx,$ny)=$pdl_V->dims;

#$call="cont_seg_all.pl ".$NAME.".V.fits 0.04 7 0.7 0.02 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.02 7 0.85 0.005 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.01 7 0.85 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.015 5 0.85 0.00 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.015 6 0.8 0.00 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

#$call="cont_seg_all.pl ".$NAME.".V.fits 0.02 7 0.8 0.005 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

#$call="cont_seg_all.pl ".$NAME.".V.fits 0.02 3 0.85 0.005 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.02 4 0.85 0.005 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

# JUST a TEST
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.1 10 0.5 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
# CORRECT ONE
#$call="cont_seg_all.pl ".$NAME.".V.fits 0.02 5.5 0.85 0.005 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

#$call=

$call="med2df.pl ".$NAME.".V.fits m".$NAME.".V.fits 2 2";
mycall($call);

$call="imarith.pl m".$NAME.".V.fits '*' ".$V_mask." m".$NAME.".V.fits";
mycall($call);

$call="create_mask_map.pl m".$NAME.".V.fits 0.005 mask.".$NAME.".V.fits";
mycall($call);


#$call="cont_seg_all.pl m".$NAME.".V.fits 0.04 10 0.50 0.01 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5.5 0.85 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5.5 0.9 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5.5 0.95 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 6.5 0.9 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5.5 0.85 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5 0.9 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";
#$call="cont_seg_all.pl m".$NAME.".V.fits 0.02 5.5 0.85 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits";

#get_SN_cube.pl CALIFA_PATH/V500/reduced_v2.2/NGC2916.V500.rscube.fits.gz map_SN.NGC2916.fits.gz signal.NGC2916.fits.gz noise.NGC2916.fits.gz
#cont_seg_all_SN.pl signal.NGC2916.fits.gz,noise.NGC2916.fits.gz 0.02 30,1 0.9 0.001 cont_seg_SN.NGC2916.fits DMASK_SN.NGC2916.fits

$call="get_SN_cube.pl ".$FILE." map_SN.".$NAME.".fits.gz signal.".$NAME.".fits.gz noise.".$NAME.".fits.gz";
mycall($call);
$call="cont_seg_all_SN.pl signal.".$NAME.".fits.gz,noise.".$NAME.".fits.gz 0.02 50,1 0.9 0.001 cont_seg.".$NAME.".fits DMASK.".$NAME.".fits > cont_seg_all_SN.".$NAME.".csv";
mycall($call);

$call="spec_extract_cube_mean.pl ".$FILE." cont_seg.".$NAME.".fits CS.".$NAME.".RSS.fits";
mycall($call);

$call="spec_extract_cube_error.pl ".$FILE." cont_seg.".$NAME.".fits e_CS.".$NAME.".RSS.fits";
mycall($call);

$call="get_SN_rss.pl CS.".$NAME.".RSS.fits SN_".$NAME.".CS.rss.csv";
mycall($call);
$call="csv_to_map.seg.pl SN_".$NAME.".CS.rss.csv 1 cont_seg.".$NAME.".fits SN_".$NAME.".CS.fits";
mycall($call);



$call="rss_seg2cube.pl CS.".$NAME.".RSS.fits cont_seg.".$NAME.".fits SEG.cube.".$NAME.".fits";
mycall($call);

$call="get_slice.pl SEG.cube.".$NAME.".fits SEG_img_".$NAME." ".$DIR_CONF."/slice_V.conf"; 
mycall($call);                                                                  
#$call="cp SEG_img_V_4500_5500.fits SEG.V.fits";
#mycall($call);                                             
$call="clean_nan.pl  SEG_img_".$NAME."_V_4500_5500.fits -1";
mycall($call);
$call="imarith.pl ".$NAME.".V.fits '/' SEG_img_".$NAME."_V_4500_5500.fits scale.seg.".$NAME.".fits";


#SEG.V.fits scale.seg.fits";
mycall($call);

print " Fitting RSS file\n";

$call="rm -f elines_auto_ssp.CS.".$NAME.".rss.out";
mycall($call);
#auto_ssp_elines_rnd_rss_disp.pl
$disp_MAX=5.5;
#$call="auto_ssp_elines_rnd_rss_disp.pl  CS.".$NAME.".RSS.fits,e_CS.".$NAME.".RSS.fits ".$template.",".$temp_2." auto_ssp.CS.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 2.8 0.3 2.3 ".$disp_MAX." 0.3 0.15 0.0 1.6";

#$temp_3="legacy/gsd61_12.fits";

#$call="auto_ssp_elines_rnd_rss_disp.pl  CS.".$NAME.".RSS.fits,e_CS.".$NAME.".RSS.fits ".$template.",".$temp_2." auto_ssp.CS.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 2.8 0.15 2.0 ".$disp_MAX." 0.3 0.15 0.0 1.6";

#$call="auto_ssp_elines_rnd_rss_disp.pl  CS.".$NAME.".RSS.fits,e_CS.".$NAME.".RSS.fits ".$template.",".$temp_3." auto_ssp.CS_few.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 2.8 0.15 2.0 ".$disp_MAX." 0.3 0.15 0.0 1.6";
#mycall($call);


#$call="auto_ssp_elines_rnd_rss_disp.pl  CS.".$NAME.".RSS.fits,e_CS.".$NAME.".RSS.fits ".$template.",".$temp_2." auto_ssp.CS.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot_rss." -2 5 3800,3850 7000,4700 none  ".$red." ".$d_red." ".$min_red." ".$max_red." 2.8 0.15 2.0 ".$disp_MAX." 0.3 0.15 0.0 1.6";

$call="auto_ssp_elines_rnd_rss_sigma_inst_disp_min.pl  CS.".$NAME.".RSS.fits,e_CS.".$NAME.".RSS.fits ".$template.",".$temp_2.",1.1 auto_ssp.CS.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config." ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt   ".$red." ".$d_red." ".$min_red." ".$max_red."  30 20 1 400 0.3 0.15 0.0 1.6";
mycall($call);

#$call="map_auto_ssp_rnd.seg.pl elines_auto_ssp.CS.".$NAME.".rss.out cont_seg.".$NAME.".fits map.CS.".$NAME." 2.32 &";
#$call="map_auto_ssp_rnd.seg.pl elines_auto_ssp.CS.".$NAME.".rss.out cont_seg.".$NAME.".fits map.CS.".$NAME." 2.32 5500 &";
$call="map_auto_ssp_rnd.seg.pl elines_auto_ssp.CS.".$NAME.".rss.out cont_seg.".$NAME.".fits map.CS.".$NAME." 2.00 5500 &";
mycall($call);

#exit;


#$call="plot_output_auto_ssp_elines_several_Av_log_rss_all.pl output.auto_ssp.CS_few.".$NAME.".rss.out.fits.gz plot_fit.CS_few.".$NAME.".ps/CPS";
$call="plot_output_auto_ssp_elines_several_Av_log_rss_all.pl output.auto_ssp.CS.".$NAME.".rss.out.fits.gz plot_fit.CS.".$NAME.".ps/CPS";
mycall($call);




#
# We analyze the indeces.
#
$call="get_index_output_auto_ssp_elines_rnd_rss_outFIT3D.pl output.auto_ssp.CS.".$NAME.".rss.out.fits.gz 5 auto_ssp.CS.".$NAME.".rss.out /null > indices.CS.".$NAME.".rss.out ";
mycall($call);
$call="./index_seg_cube.pl indices.CS.".$NAME.".rss.out cont_seg.".$NAME.".fits indices.CS.".$NAME.".cube.fits &";
mycall($call);

#print "DONE\n";


$call="FIT3D_output_rss_seg2cube.pl output.auto_ssp.CS.".$NAME.".rss.out.fits.gz 1 cont_seg.".$NAME.".fits SSP_mod_tmp.".$NAME.".cube.fits";
mycall($call);

#scale.seg.".$NAME.".fits";
#$call="imarith.pl SSP_mod.cube.fits '*' scale.seg.fits SSP_mod.".$NAME.".cube.fits";
$call="imarith.pl SSP_mod_tmp.".$NAME.".cube.fits '*' scale.seg.".$NAME.".fits SSP_mod.".$NAME.".cube.fits";
mycall($call);

$call="imarith.pl ".$FILE." '-' SSP_mod.".$NAME.".cube.fits TMP.".$NAME.".cube.fits";
mycall($call);
$call="rm -r smooth.".$NAME.".cube.fits";
mycall($call);
#$call="smooth_spec_clip_cube.pl TMP.".$NAME.".cube.fits test.cube.fits 75 1.5 10 1860";
$call="smooth_spec_clip_cube.pl TMP.".$NAME.".cube.fits smooth.".$NAME.".cube.fits 75 1.5 10 1860";
mycall($call);
$call="imarith.pl TMP.".$NAME.".cube.fits - smooth.".$NAME.".cube.fits GAS.".$NAME.".cube.fits";
mycall($call);


print " GAS.$NAME.cube.fits created\n";

#print "Press Enter\n"; <stdin>;


$WREF=6562.68;
$WMIN=$WREF*(1+$min_red)-50;
$WMAX=$WREF*(1+$max_red)+50;
$call="vel_eline_cube.pl GAS.".$NAME.".cube.fits 1 0.95 ve.".$NAME." ".$WREF." /null ".$WMIN." ".$WMAX;
mycall($call);

$min_vel=$red*$vel_light-500;
$max_vel=$red*$vel_light+500;
$call="./clean_Ha_map.pl   ve.".$NAME.".vel_map.fits ve.".$NAME.".mask_map.fits ".$max_vel." ".$min_vel;
mycall($call);

$elines_in_file="elines_auto_ssp.CS.".$NAME.".rss.out";
open(FH,"<$elines_in_file");
$line=<FH>;
$line=<FH>;
$line=<FH>; chop($line);
@dat_elines=split(" ",$line);
close(FH);
$disp_max_elines=$dat_elines[5]*1.05;


#
# Analyze cube
#
$FILE_CONF_NOW=$DIR_CONF."/".$config_SII;
open(CONF,"<$FILE_CONF_NOW");
$conf=<CONF>;
$conf=<CONF>;
$conf=<CONF>;
$nr=<CONF>;
chop($nr);
print "NR=$nr\n";
for ($j=0;$j<$nr;$j++) {
    $conf=<CONF>;
    chop($conf);
    @d_conf=split(" ",$conf);
    $w1=$d_conf[0];
    $w2=$d_conf[1];
    $w1_z=int($d_conf[0]*(1+$red));
    $w2_z=int($d_conf[1]*(1+$red));
    $in_conf=$d_conf[3];
    open(IN,"<$in_conf");
    $tmp_conf="tmp.".$NAME.".conf";
    open(TMP,">$tmp_conf");
    $ni=0;
    while($in=<IN>) {
        chop($in);
        if ($ni==5) {
            $vel1=$vel-300;
            $vel2=$vel+300;
            print TMP "$vel     1       $vel1     $vel2   -1\n";
        } else {
            if ($ni==4) {
                print TMP "2.5     1       0.75     $disp_max_elines   -1\n";
            } else {
                print TMP "$in\n";
            }
        }
        $ni++;
    }
    close(TMP);
    close(IN);
    if ($j==0) {
#	$call="./kin_back_cube_guided_error.pl  GAS.".$NAME.".cube.fits ".$FILE." ".$tmp_conf." none 0 ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out /null  ve.".$NAME.".vel_map.fits ve.".$NAME.".mask_map.fits 1 >/dev/null ";

#
# We found not difference in the Kinematics fitted and guessed with an hyperbolic curve
# Thus, we fixed the velocity map: 
#	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits  ".$tmp_conf." none ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 ve.".$NAME.".vel_map.fits,ve.".$NAME.".mask_map.fits,1 >/dev/null ";

#	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits  ".$tmp_conf." none ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 ve.".$NAME.".vel_map.fits,ve.".$NAME.".mask_map.fits,0 >/dev/null ";

#
	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits  ".$tmp_conf." none ".$w1_z." ".$w2_z." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 ve.".$NAME.".vel_map.fits,ve.".$NAME.".mask_map.fits,0 >/dev/null ";

#	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits  ".$tmp_conf." none ".$w1_z." ".$w2_z." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 >/dev/null ";

    } else {
#	$call="./kin_back_cube_fixed_error.pl  GAS.".$NAME.".cube.fits ".$FILE." tmp.conf none 0 ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out /null  map.6530_6630.".$NAME."_vel_00.fits disp.fits 1 >/dev/null ";
#	$call="./kin_back_cube_fixed_error.pl  GAS.".$NAME.".cube.fits ".$FILE." tmp.conf none 0 ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out /null  vel.fits disp.fits 1 >/dev/null ";

#	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits tmp.conf none ".$w1." ".$w2." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 ve.".$NAME.".vel_map.fits,ve.".$NAME.".mask_map.fits,1 >/dev/null ";
	$fix_disp=0;
	if ($w1==3700) {
	    $fix_disp=1;
	}
	$call="kin_cube_elines_rnd.pl  GAS.".$NAME.".cube.fits  ".$tmp_conf." none ".$w1_z." ".$w2_z." KIN.GAS.".$w1."_".$w2.".".$NAME.".out 30 3 0 0.15 map.".$w1."_".$w2.".".$NAME." 0 map.6530_6630.".$NAME."_vel_00.fits,ve.".$NAME.".mask_map.fits,0 map.6530_6630.".$NAME."_disp_00.fits,".$fix_disp." >/dev/null";

    }
    mycall($call);
#map.6530_6950.NGC5947_vel_00.fits

#    $call="mapgrid_back_rot.pl ".$nx." ".$ny." KIN.GAS.".$w1."_".$w2.".".$NAME.".out map.".$w1."_".$w2.".".$NAME." 1 >/dev/null";
#    mycall($call);
    if ($j==0) {
	$call="rm -f vel.fits";
	mycall($call);
	$call="rm -f disp.fits";
	mycall($call);
	$call="med2df.pl map.6530_6630.".$NAME."_vel_00.fits vel.".$NAME.".fits 3 3";
	mycall($call);
	$call="med2df.pl map.6530_6630.".$NAME."_disp_00.fits disp.".$NAME.".fits 3 3";
	mycall($call);
	$call="imarith.pl disp.".$NAME.".fits '/' 2.345 disp.".$NAME.".fits";
	mycall($call);
    }

    print "$w1-$w2 region analyzed\n";
}
close(CONF);

#$call="spec_extract_cube_mean.pl GAS.".$NAME.".cube.fits cont_seg.".$NAME.".fits GAS.CS.".$NAME.".RSS.fits";
#mycall($call);
#$call="imarith.pl CS.".$NAME.".RSS.fits -  GAS.CS.".$NAME.".RSS.fits CLEAN.CS.".$NAME.".RSS.fits";
#mycall($call);

# AAAAAA


#$call="cp elines_auto_ssp.CS_few.".$NAME.".rss.out elines_auto_ssp.CS.".$NAME.".rss.out";
#mycall($call);




###############################
# 30.04.2014
#
#exit;

#
# HII regions
#

$call="gzip -f *".$NAME."*.fits";
mycall($call);

$call="./ana_single_HII.pl ".$NAME;
mycall($call);

$call="./ana_single_diff.pl ".$NAME;
mycall($call);

$call="./get_CS_slice.pl ".$NAME;
mycall($call);

$call="./ana_single_elines.pl ".$NAME;
mycall($call);

open(DIR,"ls map.CS*$NAME*.fits.gz |");
while ($file=<DIR>) {
    chop($file);
    $call="imarith.pl ".$file." '*' mask.".$NAME.".V.fits.gz ".$file;
    mycall($call);
}
close(DIR);

$call="./pack_NAME.pl ".$NAME;
mycall($call);

$call="./get_real_EW_Ha_NAME.pl ".$NAME;
mycall($call);




#$call="create_mask_map.pl m".$NAME.".V.fits 0.005 mask.".$NAME.".V.fits";
#mycall($call);



print_time();
$end_time=print_time();
$delta_time=$end_time-$init_time;
print "Total Time consumed = $delta_time\n";

close(LOG);
exit;


sub print_time {
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    print "# TIME $sec $min $hour $mday $mon $year $wday $yday $isdst\n";
    print LOG "# TIME $sec $min $hour $mday $mon $year $wday $yday $isdst\n";
    my $time=time;
    return $time;
}

sub mycall {                                                                                                     
    my $call=$_[0];
    print "$call | PROCESSING\n";
    system($call);
    print LOG "$call\n";
    print "DONE\n";
}                                                                                                                
   
