#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;
$vel_light=299792.458;

$plot=2; $plot_rss=0;
#$plot=1; $plot_rss=1;

#$DIR_WORK="CALIFA_PATH/SSP/SEG/";
#$DIR_CONF="legacy/";
$DIR_CONF="../legacy/";
#legacy/
#$DIR_DATA="CALIFA_PATH/V500/reduced_v1.3c/";
#$DIR_DATA="CALIFA_PATH/V500/reduced_v2.2/";
$DIR_DATA="CALIFA_PATH/V500/reduced_v2.2/";
#chdir($DIR_WORK);
$max_size=10;
$frac=0.9;
#$template="legacy/miles_2.fits";
#$template="legacy/miles_12.fits";
#$template="legacy/miles_6.fits";
#legacy/gsd61_156.fits,legacy/miles_2.fits

$config="auto_ssp_V500_several.config";
$config_no="auto_ssp_V500_no_lines.config";


$template="legacy/gsd01_156.fits";
$temp_2="legacy/miles_3.fits";

$temp_3="legacy/gsd01_12.fits";
$temp_4="legacy/miles_2_gas.fits";


#
#$template="legacy/miles_6.fits";
#$template="legacy/miles_20.fits";
#$template="legacy/miles_4.fits";

if ($#ARGV<0) {
    print "ana_single_HII.pl NAME\n";
    exit;
}
$NAME=$ARGV[0];
$FILE=$DIR_DATA."/".$NAME.".V500.rscube.fits.gz";

$logfile="ana_single_HII.".$NAME.".log";
open(LOG,">$logfile");

print_time();

$call="read_img_header.pl ".$FILE." MED_VEL > SYS_VEL_NOW_".$NAME;
mycall($call);
$sys_vel_now="SYS_VEL_NOW_".$NAME;
open(VEL,"<$sys_vel_now");
$dat=<VEL>; chop($dat);
close(VEL);
#($key,$vel)=split(/\|/,$dat);
($key,$vel)=split(" ",$dat);
$vel =~ s/ //g;
$vel=0;

$call="vel_eline_spec.pl ".$NAME.".spec_5.txt 2 0.7 junk 3728 OII_".$NAME.".HII.ps/CPS 3700 4000 > vel_eline_spec.".$NAME.".txt";
mycall($call);

$f_eline="vel_eline_spec.".$NAME.".txt";
open(FE,"<$f_eline");
$fe=<FE>; chop($fe); @dat_fe=split(",",$fe);
close(FE);

#
# Define the redshift by OII, if it is clearly detected!
#
if (($dat_fe[1]==1)&&($vel==0)) {
    $vel=$dat_fe[2];
    $red=$vel/$vel_light;
    $min_red=$red-300/$vel_light;
    $max_red=$red+300/$vel_light;
    $d_red=30/$vel_light;
#    $call="write_img_header.pl ".$FILE." MED_VEL ".$vel;
#    mycall($call);
} else {
    $red=0.02;
    $min_red=0.0045;
    $max_red=0.032;
    $d_red=30/$vel_light;
}

$red=0.02;
$min_red=0.0045;
$max_red=0.032;
$d_red=150/$vel_light;




$call="auto_ssp_elines_rnd.pl  ".$NAME.".spec_5.txt ".$temp_3.",".$temp_4." auto_ssp_Z_HII.".$NAME.".cen.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF.$config_no." 0 -3 50 3800,3850 7000,4700 none  ".$red." ".$d_red." ".$min_red." ".$max_red." 3.2 0.3 1.2 5.5 0.3 0.15 0.0 1.6";
mycall($call);

$vel=0;
$disp_MAX=5.5;
if ($vel==0) {
    $outfile="auto_ssp_Z_HII.".$NAME.".cen.out";
    open(RED,"<$outfile");
    while($RED=<RED>) {
	if ($RED !~ "#") {
	    chop($RED);
	    @RED_DATA=split(",",$RED);
	    $red=$RED_DATA[7];
	    $min_red=$red-300/$vel_light;
	    $max_red=$red+300/$vel_light;
	    $d_red=30/$vel_light;
	    $vel=$red*$vel_light;
	    $disp_MAX=1.5*$RED_DATA[9];#+1.5*$RED_DATA[10];
	#    $disp_MAX=$RED_DATA[9]+1.5*$RED_DATA[10];
	    print "RED=$red VEL=$vel\n";
	}
    }
    close(RED);
}


$call="auto_ssp_elines_rnd.pl  ".$NAME.".spec_5.txt ".$template.",".$temp_2." auto_ssp.".$NAME.".cen.HII.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF."auto_ssp_V500_several.config ".$plot." -3 50 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." 0 ".$min_red." ".$max_red." 3.2 0.3 1.2 5.5 0.3 0.15 0.0 1.6";

#$call="auto_ssp_elines_several_Av_log_new.pl  ".$NAME.".spec_5.txt ".$template." auto_ssp.".$NAME.".cen.HII.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF."auto_ssp_V500_several.config ".$plot." -3 50 3800 6800 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 4.5 0.5 1.2 9.0 0.5 0.1 0.0 1.6";
mycall($call);


$vel=0;
$disp_MAX=5.5;
if ($vel==0) {
    $outfile="auto_ssp.".$NAME.".cen.HII.out";
    open(RED,"<$outfile");
    while($RED=<RED>) {
	if ($RED !~ "#") {
	    chop($RED);
	    @RED_DATA=split(",",$RED);
	    $red=$RED_DATA[7];
	    $min_red=$red-300/$vel_light;
	    $max_red=$red+300/$vel_light;
	    $d_red=30/$vel_light;
	    $vel=$red*$vel_light;
#	    $disp_MAX=$RED_DATA[9]+0.5*$RED_DATA[10];
	    $disp_MAX=1.5*$RED_DATA[9];#+1.5*$RED_DATA[10];
	    print "RED=$red VEL=$vel\n";
	}
    }
    close(RED);
}


#
# HII regions
#


$call="correct_vel_map_cube_rot.pl ".$FILE." ve.".$NAME.".vel_map.fits.gz ".$NAME.".V500.zcube.fits.gz ".$vel;
mycall($call);

$call="correct_vel_map_cube_rot.pl  GAS.".$NAME.".cube.fits.gz ve.".$NAME.".vel_map.fits.gz GAS.".$NAME.".zcube.fits.gz ".$vel;
mycall($call);
#exit;

$FILE_z=$NAME.".V500.zcube.fits.gz";

$call="get_Ha.pl ".$FILE_z." ".$red." map_Ha.".$NAME.".fits.gz";
mycall($call);

#0.5 4 0.15 0.1 
#0.5 4 0.15 0.1 
$call="HII_recover.pl map_Ha.".$NAME.".fits.gz 0.3 3.5 0.1 0.1  seg_Ha.".$NAME.".fits.gz mask_Ha.".$NAME.".fits.gz > HII_recover.".$NAME.".log";
#$call="HII_recover.pl map_Ha.".$NAME.".fits.gz 1.0 3.5 0.15 0.1  seg_Ha.".$NAME.".fits.gz mask_Ha.".$NAME.".fits.gz > HII_recover.".$NAME.".log";
mycall($call);
$call="./plot_seg_map.py ".$NAME;
mycall($call);
$call="spec_extract_cube.pl ".$FILE_z." seg_Ha.".$NAME.".fits.gz HII.".$NAME.".rss.fits.gz seg_diff.".$NAME.".fits.gz";
mycall($call);
$call="spec_extract_cube_error.pl ".$FILE." seg_Ha.".$NAME.".fits.gz e_HII.".$NAME.".rss.fits.gz";
mycall($call);

#$d_red=0;

$min_red=$red-20/$vel_light;
$max_red=$red+20/$vel_light;
$d_red=5/$vel_light;

$call="rm -f elines_auto_ssp.HII.".$NAME.".rss.out";
mycall($call);

#$call="auto_ssp_elines_rnd_rss.pl  HII.".$NAME.".rss.fits.gz,e_HII.".$NAME.".rss.fits.gz ".$template.",".$temp_2." auto_ssp.HII.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF."auto_ssp_V500_several.config ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." ".$d_red." ".$min_red." ".$max_red." 3.2 0.3 1.2 ".$disp_MAX." 0.3 0.15 0.0 1.6";
#
$disp_ALL=0.9*$disp_MAX;
if ($disp_MAX>5.5) {
    $ditp_MAX=5.5;
}


$call="auto_ssp_elines_rnd_rss_sigma_inst.pl  HII.".$NAME.".rss.fits.gz,e_HII.".$NAME.".rss.fits.gz,1.1 ".$template.",".$temp_2." auto_ssp.HII.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF."auto_ssp_V500_several.config ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." 0 ".$min_red." ".$max_red." 30 20 1 400 0.3 0.15 0.0 1.6";

#$call="auto_ssp_elines_rnd_rss.pl  HII.".$NAME.".rss.fits.gz,e_HII.".$NAME.".rss.fits.gz ".$template.",".$temp_2." auto_ssp.HII.".$NAME.".rss.out ".$DIR_CONF."/mask_elines.txt ".$DIR_CONF."auto_ssp_V500_several.config ".$plot_rss." -2 5 3800,3850 7000,4700 ".$DIR_CONF."/emission_lines.txt  ".$red." 0 ".$min_red." ".$max_red." 3.0 0.3 2.5 ".$disp_MAX." 0.3 0.15 0.0 1.6";
mycall($call);

$call="gzip -f *".$NAME."*.fits";
mycall($call);

$call="plot_output_auto_ssp_elines_several_Av_log_rss_all.pl output.auto_ssp.HII.".$NAME.".rss.out.fits.gz plot_fit.HII.".$NAME.".ps/CPS ";
mycall($call);

$call="get_index_output_auto_ssp_elines_rnd_rss_outFIT3D.pl output.auto_ssp.HII.".$NAME.".rss.out.fits.gz 5 auto_ssp.HII.".$NAME.".rss.out /null > indices.HII.".$NAME.".rss.out";
mycall($call);


$call="cp HII.".$NAME.".rss.pt.txt.gz  HII.".$NAME.".rss.pt.txt";
mycall($call);

$call="./sum_mass_age.pl ".$NAME." > MASS.".$NAME.".csv";
mycall($call);

print_time();
close(LOG);
exit;


sub print_time {
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    print "# TIME $sec $min $hour $mday $mon $year $wday $yday $isdst\n";
    print LOG "# TIME $sec $min $hour $mday $mon $year $wday $yday $isdst\n";
}

sub mycall {                                                                                                     
    my $call=$_[0];
    print "$call | PROCESSING\n";
    system($call);
    print LOG "$call\n";
    print "DONE\n";
}                                                                                                                
   
