#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Core;
use PDL::Graphics::LUT;
use Carp;
use PDL::Image2D;
$ENV{PGPLOT_FOREGROUND} = "black";
$ENV{PGPLOT_BACKGROUND} = "white";



#require "/work1/ssa/perl/MY/my.pl";
#require "/home/sanchez/3DSoft_Ubuntu/R3D/my.pl";
#require "/home/sanchez/sda2/code/R3D/my.pl";

$F3D=$ENV{FIT3D_PATH}; $F3D=$ENV{FIT3D_PATH}; require("$F3D/scripts/my.pl");



if ($#ARGV<0) {
    print "USE: get_CS_slice.pl name\n";
    exit;
}
$name=$ARGV[0];

$segfile="cont_seg.".$name.".fits.gz";
$mapHa=$name.".V.fits.gz";
$output="CS.".$name.".slice";

$seg=rfits($segfile);
$Ha=rfits($mapHa);

($nx,$ny)=$seg->dims;

$n=0;
my @flux;
my @X;
my @Y;
my @A;
for ($i=0;$i<$nx;$i++) {
    for ($j=0;$j<$ny;$j++) {
	$ID=$seg->at($i,$j);
	if ($ID>0) {
	    if ($n<$ID) {
		$n=$ID;
	    }
	    $val=$Ha->at($i,$j);
	    if ($val==0) {
		$val=1;
	    }
	    $flux[$ID]=$flux[$ID]+$val;
	    $X[$ID]=$X[$ID]+$i*$val;
	    $Y[$ID]=$Y[$ID]+$j*$val;
	    $A[$ID]=$A[$ID]+1;
	}
    }
}

open(OUT,">$output");
print OUT "# (1) ID\n";
print OUT "# (2) X\n";
print OUT "# (3) Y\n";
print OUT "# (4) Flux\n";
print OUT "# (5) Area\n";
for ($i=1;$i<=$n;$i++) {
    if ($flux[$i]>0) {
	$x=$X[$i]/$flux[$i];
	$y=$Y[$i]/$flux[$i];
    } else {
	$x=$X[$i]/$flux[$i];
	$y=$Y[$i]/$flux[$i];
    }
    print OUT "$i  $x  $y   $flux[$i] $A[$i]\n";
}

exit;
