#!/usr/bin/perl

use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use  PDL::Fit::Linfit;


$F3D=$ENV{FIT3D_PATH}; $F3D=$ENV{FIT3D_PATH}; require("$F3D/scripts/my.pl");


my $speed_of_light=299792.458;

#    srand(localtime);

if ($#ARGV<2) {
    print "USE: pack_results_name.pl NAME pack_CS.csv PREFIX\n";
    exit;
}

$name=$ARGV[0];
$pack=$ARGV[1];
$prefix=$ARGV[2];

$np=0;
open(FH,"<$pack");
while($line=<FH>) {
    chop($line);
    if ($line !~ "#") {
	$line =~ s/NAME/$name/g;
	$LINE[$np]=$line;
	$np++;
    }
}
close(FH);

my $pdl_cube;
for ($i=0;$i<$np;$i++) {
    my $pdl_img;
    $line=$LINE[$i];
    @data=split(",",$line);
    $pdl_img=rfits($data[1]);
    if ($i==0) {
	($nx,$ny)=$pdl_img->dims();
	$pdl_cube=zeroes($nx,$ny,$np);
	$h = {NAXIS=>3, NAXIS1=>$nx, NAXIS2=>$ny, NAXIS3=> $np, COMMENT=>"FITs header"};
	$head="OBJECT";
	$$h{$head}=$name;
    }
    $t=$pdl_cube->slice(":,:,($i)");
    $t .= $pdl_img;
    $head="ID_".$i;
    $$h{$head}=$data[0];
    $head="FILE_".$i;
    $$h{$head}=$data[1];
    $head="DESC_".$i;
    $$h{$head}=$data[2];
    $head="TYPE_".$i;
    $$h{$head}=$data[3];
    $head="UNITS_".$i;
    $$h{$head}=$data[4];
}
$pdl_cube->sethdr($h);

$output=$name.".".$prefix.".cube.fits.gz";
$pdl_cube->wfits($output);

exit;



