#!/usr/bin/perl
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;


$DIR_DATA="CALIFA_PATH/V500/reduced_v2.2/";
#$DIR_DATA="CALIFA_PATH/V500/reduced_v1.3c/";

$max_size=10;
$frac=0.9;


$n=0;
open(DIR,"ls HII.*.rss.fits.gz |");
while($file=<DIR>) {
    chop($file);
    $name=$file;
    $cut=".rss.fits.gz";
    $name =~ s/$cut//;
    $cut="HII.";
    $name =~ s/$cut//;
    $FILE[$n]=$file;
    $NAME[$n]=$name;
    $n++;    
}
close(DIR);

open(LOG,">plot_HII.log");
for ($i=0;$i<$n;$i++) {    

    $call="plot_output_auto_ssp_elines_several_Av_log_rss_all.pl output.auto_ssp.HII.".$NAME[$i].".rss.out.rss.fits.gz plot_fit.HII.".$NAME[$i].".ps/CPS ";
    mycall($call);

}
close(LOG);
exit;

sub mycall {                                      
                                                                   my $call=$_[0];

														     print "$call | PROCESSING\n";                                                                                 
    system($call);                                                                                                
    print LOG "$call\n";                                                                                          
    print "DONE\n";                                                                                              
} 
